Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/Makefile	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -40,8 +40,5 @@
 	$(PACK) $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) arch/$(KARCH) $(COMPONENTS)
 
-$(INITRD).img: $(INITRD).fs
-	$(MKHORD) $(PAGE_SIZE) $< $@
-
-$(INITRD).fs: build_dist
+$(INITRD).img: build_dist
 ifeq ($(RDFMT),tmpfs)
 	$(MKTMPFS) $(DIST_PATH) $@
@@ -95,5 +92,5 @@
 
 clean_dist:
-	rm -f $(INITRD).fs $(INITRD).img $(COMPS_H) $(COMPS_C) $(LINK) $(LINK).comp *.co
+	rm -f $(INITRD).img $(COMPS_H) $(COMPS_C) $(LINK) $(LINK).comp *.co
 	rm -f $(USPACE_PATH)/dist/srv/*
 	rm -rf $(USPACE_PATH)/dist/drv/*
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/Makefile.common	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -53,5 +53,4 @@
 SANDBOX = pack
 PACK = $(TOOLS_PATH)/pack.py
-MKHORD = $(TOOLS_PATH)/mkhord.py
 MKTMPFS = $(TOOLS_PATH)/mktmpfs.py
 MKFAT = $(TOOLS_PATH)/mkfat.py
Index: boot/Makefile.grub
===================================================================
--- boot/Makefile.grub	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/Makefile.grub	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -31,38 +31,66 @@
 include Makefile.common
 
-GRUB2 = grub
-STAGE2 = $(GRUB2)/i386-pc/eltorito.img
-STAGE2_IN = boot/$(STAGE2)
+GRUB = grub.$(GRUB_ARCH)
+BOOT = $(DISTROOT)/boot
+
+ELTORITO = boot/grub/$(GRUB_ARCH).img
+IMAGE = $(DISTROOT)/$(ELTORITO)
+
+ifeq ($(GRUB_ARCH),pc)
+	BOOT_CONFIG = $(BOOT)/grub/i386-pc/grub.cfg
+	MULTIBOOT_CMD = multiboot
+	MODULE_CMD = module
+endif
+ifeq ($(GRUB_ARCH),efi)
+	BOOT_CONFIG = $(BOOT)/grub/grub.cfg
+	MULTIBOOT_CMD = multiboot2
+	MODULE_CMD = module2
+endif
 
 all: $(BOOT_OUTPUT)
 
 $(BOOT_OUTPUT): build_dist
-	mkisofs -J -r -input-charset utf-8 -b $(STAGE2_IN) -no-emul-boot -boot-load-size 64 -boot-info-table -o $@ $(DISTROOT)/
+ifeq ($(GRUB_ARCH),pc)
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -eltorito-boot $(ELTORITO) -no-emul-boot -boot-load-size 64 -boot-info-table -o $@ $(DISTROOT)/
+endif
+ifeq ($(GRUB_ARCH),efi)
+	mkisofs -J -r -input-charset utf-8 -V "HelenOS boot ISO" -efi-boot $(ELTORITO) -o $@ $(DISTROOT)/
+endif
 
 build_dist: clean
-	mkdir -p $(DISTROOT)/boot
-	cp -r $(GRUB2) $(DISTROOT)/boot
+	mkdir -p $(BOOT)
+	cp -r $(GRUB) $(BOOT)/grub
+ifeq ($(GRUB_ARCH),efi)
+	gunzip $(IMAGE)
+endif
+	
 	for module in $(COMPONENTS) ; do \
-		cp "$$module" $(DISTROOT)/boot/ ; \
+		cp "$$module" $(BOOT)/ ; \
 	done
 	
-	echo "set default=0" > $(DISTROOT)/boot/grub/i386-pc/grub.cfg
-	echo "set timeout=10" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg
-	echo "" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg
+	echo "set default=0" > $(BOOT_CONFIG)
+	echo "set timeout=10" >> $(BOOT_CONFIG)
+	echo "" >> $(BOOT_CONFIG)
 	
-	echo "menuentry 'HelenOS $(RELEASE)' --class helenos --class os {" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg
-	echo "	set root='(cd)'" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg
+ifeq ($(GRUB_ARCH),pc)
+	echo "insmod vbe" >> $(BOOT_CONFIG)
+	echo "insmod vga" >> $(BOOT_CONFIG)
+endif
+ifeq ($(GRUB_ARCH),efi)
+	echo "insmod efi_gop" >> $(BOOT_CONFIG)
+	echo "insmod efi_uga" >> $(BOOT_CONFIG)
+endif
+	echo "" >> $(BOOT_CONFIG)
 	
+	echo "menuentry 'HelenOS $(RELEASE)' --class helenos --class os {" >> $(BOOT_CONFIG)
 	for module in $(MODULES) ; do \
-		echo "" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg ; \
-		echo "	echo 'Loading $$module'" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg ; \
+		echo "	echo 'Loading $$module'" >> $(BOOT_CONFIG) ; \
 		if [ "$$module" = "kernel.bin" ] ; then \
-			echo "	multiboot /boot/$$module" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg ; \
+			echo "	$(MULTIBOOT_CMD) /boot/$$module" >> $(BOOT_CONFIG) ; \
 		else \
-			echo "	module /boot/$$module" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg ; \
+			echo "	$(MODULE_CMD) /boot/$$module" >> $(BOOT_CONFIG) ; \
 		fi \
 	done
-	
-	echo "}" >> $(DISTROOT)/boot/grub/i386-pc/grub.cfg
+	echo "}" >> $(BOOT_CONFIG)
 
 clean:
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/amd64/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -26,6 +26,4 @@
 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 #
-
-PAGE_SIZE = 4096
 
 RD_SRVS_ESSENTIAL += \
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/arm32/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -39,5 +39,4 @@
 BITS = 32
 ENDIANESS = LE
-PAGE_SIZE = 4096
 
 RD_SRVS_ESSENTIAL += \
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/ia64/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -33,5 +33,4 @@
 BITS = 64
 ENDIANESS = LE
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -fno-unwind-tables -mfixed-range=f32-f127 -mno-pic -mno-sdata
 
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/mips32/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -29,5 +29,4 @@
 BFD_ARCH = mips
 BITS = 32
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3 -mabi=32
 
Index: boot/arch/mips64/Makefile.inc
===================================================================
--- boot/arch/mips64/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/mips64/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -29,5 +29,4 @@
 BFD_ARCH = mips:4000
 BITS = 64
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3 -mabi=64
 
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/ppc32/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -37,5 +37,4 @@
 BITS = 32
 ENDIANESS = BE
-PAGE_SIZE = 4096
 EXTRA_CFLAGS = -mcpu=powerpc -msoft-float -m32
 
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision 07fd4cd12c13e7fea58e90f7cd905868c715f57c)
+++ boot/arch/sparc64/Makefile.inc	(revision b8b1e6316d7aaa2e058c2099df2fd5541df4abaa)
@@ -37,5 +37,4 @@
 BITS = 64
 ENDIANESS = BE
-PAGE_SIZE = 16384
 EXTRA_CFLAGS = -mcpu=ultrasparc -m64 -mno-fpu -mcmodel=medlow
 
